## rustc-1.76 1.76.0+dfsg0ubuntu1

=== tests/run-make-fulldeps/obtain-borrowck/Makefile ===
include ../../run-make/tools.mk

# This example shows how to implement a rustc driver that retrieves MIR bodies
# together with the borrow checker information.

# How to run this
# $ ./x.py test tests/run-make-fulldeps/obtain-borrowck

DRIVER_BINARY := "$(TMPDIR)"/driver
SYSROOT := $(shell $(RUSTC) --print sysroot)

ifdef IS_WINDOWS
LIBSTD := -L "$(SYSROOT)\\lib\\rustlib\\$(TARGET)\\lib"
else
LIBSTD :=
endif

all:
	$(RUSTC) driver.rs -o "$(DRIVER_BINARY)"
	$(TARGET_RPATH_ENV) "$(DRIVER_BINARY)" --sysroot $(SYSROOT) $(LIBSTD) test.rs -o "$(TMPDIR)/driver_test" > "$(TMPDIR)"/output.stdout

ifdef RUSTC_BLESS_TEST
	cp "$(TMPDIR)"/output.stdout output.stdout
else
	$(DIFF) output.stdout "$(TMPDIR)"/output.stdout
endif

=== tests/run-make/a-b-a-linker-guard/Makefile ===
# ignore-cross-compile
include ../tools.mk

# Test that if we build `b` against a version of `a` that has one set
# of types, it will not run with a dylib that has a different set of
# types.

# NOTE(eddyb) this test only works with the `legacy` mangling,
# and will probably get removed once `legacy` is gone.

all:
	$(RUSTC) a.rs --cfg x -C prefer-dynamic -Z unstable-options -C symbol-mangling-version=legacy
	$(RUSTC) b.rs -C prefer-dynamic -Z unstable-options -C symbol-mangling-version=legacy
	$(call RUN,b)
	$(RUSTC) a.rs --cfg y -C prefer-dynamic -Z unstable-options -C symbol-mangling-version=legacy
	$(call FAIL,b)

=== tests/run-make/archive-duplicate-names/Makefile ===
# ignore-cross-compile
include ../tools.mk

all:
	mkdir $(TMPDIR)/a
	mkdir $(TMPDIR)/b
	$(call COMPILE_OBJ,$(TMPDIR)/a/foo.o,foo.c)
	$(call COMPILE_OBJ,$(TMPDIR)/b/foo.o,bar.c)
	$(AR) crus $(TMPDIR)/libfoo.a $(TMPDIR)/a/foo.o $(TMPDIR)/b/foo.o
	$(RUSTC) foo.rs
	$(RUSTC) bar.rs
	$(call RUN,bar)

=== tests/run-make/c-link-to-rust-va-list-fn/Makefile ===
# ignore-cross-compile
include ../tools.mk

all:
	$(RUSTC) checkrust.rs
	$(CC) test.c $(call STATICLIB,checkrust) $(call OUT_EXE,test) $(EXTRACFLAGS)
	$(call RUN,test)

=== tests/run-make/c-unwind-abi-catch-lib-panic/Makefile ===
# ignore-cross-compile
# needs-unwind
include ../tools.mk

all: archive
	# Compile `main.rs`, which will link into our library, and run it.
	$(RUSTC) main.rs
	$(call RUN,main)

ifdef IS_MSVC
archive: add.o panic.o
	# Now, create an archive using these two objects.
	$(AR) crus $(TMPDIR)/add.lib $(TMPDIR)/add.o $(TMPDIR)/panic.o
else
archive: add.o panic.o
	# Now, create an archive using these two objects.
	$(AR) crus $(TMPDIR)/libadd.a $(TMPDIR)/add.o $(TMPDIR)/panic.o
endif

# Compile `panic.rs` into an object file.
#
# Note that we invoke `rustc` directly, so we may emit an object rather
# than an archive. We'll do that later.
panic.o:
	$(BARE_RUSTC) $(RUSTFLAGS)  \
		--out-dir $(TMPDIR) \
		--emit=obj panic.rs

# Compile `add.c` into an object file.
add.o:
	$(call COMPILE_OBJ,$(TMPDIR)/add.o,add.c)

=== tests/run-make/cat-and-grep-sanity-check/Makefile ===
include ../tools.mk

all:
	echo a | $(CGREP) a
	! echo b | $(CGREP) a
	echo xyz | $(CGREP) x y z
	! echo abc | $(CGREP) b c d
	printf "x\ny\nz" | $(CGREP) x y z

	echo AbCd | $(CGREP) -i a b C D
	! echo AbCd | $(CGREP) a b C D

	true | $(CGREP) -v nothing
	! echo nothing | $(CGREP) -v nothing
	! echo xyz | $(CGREP) -v w x y
	! echo xyz | $(CGREP) -v x y z
	echo xyz | $(CGREP) -v a b c

	! echo 'foo bar baz' | $(CGREP) 'foo baz'
	echo 'foo bar baz' | $(CGREP) foo baz
	echo 'x a `b` c y z' | $(CGREP) 'a `b` c'

	echo baaac | $(CGREP) -e 'ba*c'
	echo bc | $(CGREP) -e 'ba*c'
	! echo aaac | $(CGREP) -e 'ba*c'

	echo aaa | $(CGREP) -e 'a+'
	! echo bbb | $(CGREP) -e 'a+'

	echo abc | $(CGREP) -e 'a|e|i|o|u'
	! echo fgh | $(CGREP) -e 'a|e|i|o|u'
	echo abc | $(CGREP) -e '[aeiou]'
	! echo fgh | $(CGREP) -e '[aeiou]'
	! echo abc | $(CGREP) -e '[^aeiou]{3}'
	echo fgh | $(CGREP) -e '[^aeiou]{3}'
	echo ab cd ef gh | $(CGREP) -e '\bcd\b'
	! echo abcdefgh | $(CGREP) -e '\bcd\b'
	echo xyz | $(CGREP) -e '...'
	! echo xy | $(CGREP) -e '...'
	! echo xyz | $(CGREP) -e '\.\.\.'
	echo ... | $(CGREP) -e '\.\.\.'

	echo foo bar baz | $(CGREP) -e 'foo.*baz'
	! echo foo bar baz | $(CGREP) -ve 'foo.*baz'
	! echo foo bar baz | $(CGREP) -e 'baz.*foo'
	echo foo bar baz | $(CGREP) -ve 'baz.*foo'

=== tests/run-make/compressed-debuginfo/Makefile ===
# ignore-cross-compile
include ../tools.mk

# only-linux
#
# This tests debuginfo-compression.

all: zlib zstandard

zlib:
	test "`$(RUSTC) --crate-name=foo --crate-type=lib --emit=obj -C debuginfo=full -Z debuginfo-compression=zlib foo.rs 2>&1 | sed 's/.*unknown.*zlib.*/missing/' | head -n 1`" = missing || readelf -t $(TMPDIR)/foo.o | grep -q ZLIB

zstandard:
	test "`$(RUSTC) --crate-name=foo --crate-type=lib --emit=obj -C debuginfo=full -Z debuginfo-compression=zstd foo.rs 2>&1 | sed 's/.*unknown.*zstd.*/missing/' | head -n 1`" = missing || readelf -t $(TMPDIR)/foo.o | grep -q ZST

=== tests/run-make/core-no-fp-fmt-parse/Makefile ===
include ../tools.mk

all:
	$(RUSTC) --edition=2021 -Dwarnings --crate-type=rlib ../../../library/core/src/lib.rs --cfg no_fp_fmt_parse

=== tests/run-make/core-no-oom-handling/Makefile ===
include ../tools.mk

FAKEROOT=$(TMPDIR)/fakeroot

all:
	$(RUSTC) --edition=2021 -Dwarnings --crate-type=rlib ../../../library/core/src/lib.rs --sysroot=$(FAKEROOT) --cfg no_global_oom_handling

=== tests/run-make/dump-ice-to-disk/Makefile ===
include ../tools.mk

# ignore-windows

export RUSTC := $(RUSTC_ORIGINAL)
export LD_LIBRARY_PATH := $(HOST_RPATH_DIR)
export TMPDIR := $(TMPDIR)

all:
	bash check.sh

=== tests/run-make/emit-named-files/Makefile ===
include ../tools.mk

OUT=$(TMPDIR)/emit

all: asm llvm-bc llvm-ir obj metadata link dep-info mir

asm: $(OUT)
	$(RUSTC) --emit asm=$(OUT)/libfoo.s foo.rs
	test -f $(OUT)/libfoo.s
llvm-bc: $(OUT)
	$(RUSTC) --emit llvm-bc=$(OUT)/libfoo.bc foo.rs
	test -f $(OUT)/libfoo.bc
llvm-ir: $(OUT)
	$(RUSTC) --emit llvm-ir=$(OUT)/libfoo.ll foo.rs
	test -f $(OUT)/libfoo.ll
obj: $(OUT)
	$(RUSTC) --emit obj=$(OUT)/libfoo.o foo.rs
	test -f $(OUT)/libfoo.o
metadata: $(OUT)
	$(RUSTC) --emit metadata=$(OUT)/libfoo.rmeta foo.rs
	test -f $(OUT)/libfoo.rmeta
link: $(OUT)
	$(RUSTC) --emit link=$(OUT)/libfoo.rlib foo.rs
	test -f $(OUT)/libfoo.rlib
dep-info: $(OUT)
	$(RUSTC) --emit dep-info=$(OUT)/libfoo.d foo.rs
	test -f $(OUT)/libfoo.d
mir: $(OUT)
	$(RUSTC) --emit mir=$(OUT)/libfoo.mir foo.rs
	test -f $(OUT)/libfoo.mir

$(OUT):
	mkdir -p $(OUT)

=== tests/run-make/emit-shared-files/Makefile ===
include ../tools.mk

INVOCATION_ONLY = $(TMPDIR)/invocation-only
TOOLCHAIN_ONLY = $(TMPDIR)/toolchain-only
ALL_SHARED = $(TMPDIR)/all-shared

all: invocation-only toolchain-only all-shared

invocation-only:
	$(RUSTDOC) -Z unstable-options --emit=invocation-specific --output $(INVOCATION_ONLY) --resource-suffix=-xxx --theme y.css --extend-css z.css x.rs
	[ -e $(INVOCATION_ONLY)/search-index-xxx.js ]
	[ -e $(INVOCATION_ONLY)/settings.html ]
	[ -e $(INVOCATION_ONLY)/x/all.html ]
	[ -e $(INVOCATION_ONLY)/x/index.html ]
	[ -e $(INVOCATION_ONLY)/theme-xxx.css ] # generated from z.css
	! [ -e $(INVOCATION_ONLY)/storage-xxx.js ]
	! [ -e $(INVOCATION_ONLY)/SourceSerif4-It.ttf.woff2 ]

	# FIXME: this probably shouldn't have a suffix
	[ -e $(INVOCATION_ONLY)/y-xxx.css ]
	# FIXME: this is technically incorrect (see `write_shared`)
	! [ -e $(INVOCATION_ONLY)/main-xxx.js ]

toolchain-only:
	$(RUSTDOC) -Z unstable-options --emit=toolchain-shared-resources --output $(TOOLCHAIN_ONLY) --resource-suffix=-xxx --extend-css z.css x.rs
	[ -e $(TOOLCHAIN_ONLY)/static.files/storage-*.js ]
	[ -e $(TOOLCHAIN_ONLY)/static.files/SourceSerif4-It-*.ttf.woff2 ]
	! [ -e $(TOOLCHAIN_ONLY)/search-index-xxx.js ]
	! [ -e $(TOOLCHAIN_ONLY)/x/index.html ]
	! [ -e $(TOOLCHAIN_ONLY)/theme.css ]

	[ -e $(TOOLCHAIN_ONLY)/static.files/main-*.js ]
	! [ -e $(TOOLCHAIN_ONLY)/y-xxx.css ]

all-shared:
	$(RUSTDOC) -Z unstable-options --emit=toolchain-shared-resources,unversioned-shared-resources --output $(ALL_SHARED) --resource-suffix=-xxx --extend-css z.css x.rs
	[ -e $(ALL_SHARED)/static.files/storage-*.js ]
	[ -e $(ALL_SHARED)/static.files/SourceSerif4-It-*.ttf.woff2 ]
	! [ -e $(ALL_SHARED)/search-index-xxx.js ]
	! [ -e $(ALL_SHARED)/settings.html ]
	! [ -e $(ALL_SHARED)/x ]
	! [ -e $(ALL_SHARED)/src ]
	! [ -e $(ALL_SHARED)/theme.css ]

	[ -e $(ALL_SHARED)/static.files/main-*.js ]
	! [ -e $(ALL_SHARED)/y-xxx.css ]

=== debian/changelog ===
rustc-1.76 (1.76.0+dfsg0ubuntu1-0ubuntu0.24.04) noble; urgency=medium

  * Backport to Noble (LP: #2052985)

 -- Zixing Liu <zixing.liu@canonical.com>  Tue, 25 Jun 2024 10:06:58 -0600

=== debian/control ===
Source: rustc-1.76
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Ximin Luo <infinity0@debian.org>,
 Sylvestre Ledru <sylvestre@debian.org>,
 Fabian Grünbichler <debian@fabian.gruenbichler.email>
Rules-Requires-Root: no
# :native annotations are to support cross-compiling, see README.Debian
Build-Depends:
 debhelper (>= 9),
 debhelper-compat (= 13),
 dh-cargo (>= 28ubuntu1~),
 dpkg-dev (>= 1.17.14),
 python3:native,
 cargo:native (>= 1.75.0+dfsg) | cargo-1.76 <!pkg.rustc.dlstage0>,
 rustc:native (>= 1.75.0+dfsg) | rustc-1.76 <!pkg.rustc.dlstage0>,
 rustc:native (<= 1.77.1++)    | rustc-1.76 <!pkg.rustc.dlstage0>,
 llvm-17-dev:native,
 llvm-17-tools:native,
 libclang-rt-17-dev (>= 1:17.0.2),
 libclang-common-17-dev (>= 1:17.0.2),
 cmake (>= 3.0) | cmake3,
# needed by some vendor crates
 pkg-config,
# this is sometimes needed by rustc_llvm
 zlib1g-dev:native,
 zlib1g-dev,
# used by rust-installer
 liblzma-dev:native,
# used by cargo
 bash-completion,
 libcurl4-gnutls-dev | libcurl4-openssl-dev,
 libssh2-1-dev,
 libgit2-dev (>= 1.7.0),
 libgit2-dev (<< 1.8~~),
 libhttp-parser-dev,
 libsqlite3-dev,
# test dependencies:
 binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
 git <!nocheck>,
 procps <!nocheck>,
# Resources loaded from the docs, checked by linkchecker
 libjs-jquery <!nocheck>,
 libjs-highlight.js <!nocheck>,
 libjs-mathjax <!nocheck>,
 fonts-open-sans <!nocheck>,
 fonts-font-awesome <!nocheck>,
# below are optional tools even for 'make check'
 gdb (>= 7.12) <!nocheck>,
 libc6-dbg [armhf],
# Extra build-deps needed for x.py to download stuff in pkg.rustc.dlstage0.
 curl <pkg.rustc.dlstage0>,
 ca-certificates <pkg.rustc.dlstage0>,
Build-Depends-Indep:
 clang-17:native,
 libssl-dev,
Build-Conflicts: gdb-minimal (<< 8.1-0ubuntu6) <!nocheck>
Standards-Version: 4.6.2
Homepage: http://www.rust-lang.org/
Vcs-Git: https://salsa.debian.org/rust-team/rust.git
Vcs-Browser: https://salsa.debian.org/rust-team/rust

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# The build regressed back when LTO was systematized in Ubuntu.
# This should be periodically revisited.
export DEB_BUILD_MAINT_OPTIONS=optimize=-lto

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk
include /usr/share/dpkg/architecture.mk
SED_VERSION_SHORT := sed -re 's/([^.]+)\.([^.]+)\..*/\1.\2/'
RUST_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | $(SED_VERSION_SHORT))
RUST_LONG_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | sed -re 's/([^+]+).*/\1/')
RUST_PREV_VERSION=$(shell echo '$(RUST_LONG_VERSION)' | awk 'BEGIN{FS="."} {print $$1"."($$2)-1"."$$3}')
RUST_NEXT_VERSION=$(shell echo '$(RUST_LONG_VERSION)' | awk 'BEGIN{FS="."} {print $$1"."($$2)+1"."$$3+1}')
LIBSTD_PKG := libstd-rust-$(RUST_VERSION)
# Sed expression that matches the "rustc" we have in our Build-Depends field
SED_RUSTC_BUILDDEP := sed -ne "/^Build-Depends:/,/^[^[:space:]\#]/{/^ *rustc:native .*,/p}" debian/control
# Version of /usr/bin/rustc
LOCAL_RUST_VERSION := $(shell rustc --version --verbose | sed -ne 's/^release: //p')

include /usr/share/dpkg/buildflags.mk
# needed for cross-compilation to avoid passing host CFLAGS to the BUILD
# compiler
export TARGET_CFLAGS = $(CFLAGS)
export TARGET_CXXFLAGS = $(CXXFLAGS)
export TARGET_CPPFLAGS = $(CPPFLAGS)
export TARGET_LDFLAGS = $(LDFLAGS)
unexport CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export CARGO_HOME = $(CURDIR)/debian/cargo

# Defines DEB_*_RUST_TYPE triples
include debian/architecture.mk
# for dh_install substitution variable
export DEB_HOST_RUST_TYPE

# for dh_install substitution variable
export RUST_LONG_VERSION
export RUST_VERSION

DEB_DESTDIR := $(CURDIR)/debian/tmp

# Use system LLVM (comment out to use vendored LLVM)
LLVM_VERSION = 17
OLD_LLVM_VERSION = $(shell echo "$$(($(LLVM_VERSION)-1))")
# used by the patched profiler build script
CLANG_RT_ARCH := $(DEB_TARGET_GNU_CPU)
ifeq (i386,$(DEB_TARGET_ARCH))
CLANG_RT_ARCH = i386
endif
ifeq (armhf,$(DEB_TARGET_ARCH))
CLANG_RT_ARCH = armhf
endif
export DEB_LLVM_VERSION = $(LLVM_VERSION)
export DEB_CLANG_RT_ARCH = $(CLANG_RT_ARCH)
# Cargo-specific flags
export LIBSSH2_SYS_USE_PKG_CONFIG=1
# Make it easier to test against a custom LLVM
ifneq (,$(LLVM_DESTDIR))
LLVM_LIBRARY_PATH := $(LLVM_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(LLVM_DESTDIR)/usr/lib
LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(LLVM_LIBRARY_PATH),$(LLVM_LIBRARY_PATH))
export LD_LIBRARY_PATH
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
ifeq ($(DEB_HOST_ARCH),riscv64)
NJOBS := -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
NJOBS := -j 4
endif
endif
RUSTBUILD = RUST_BACKTRACE=1 python3 src/bootstrap/bootstrap.py $(NJOBS)
RUSTBUILD_FLAGS = --stage 2 --config debian/config.toml --on-fail env
# rust-tidy depends on lots of modules that we strip out of the build.
# it also tries to access the network for some reason. so just disable it.
RUSTBUILD_TEST = $(RUSTBUILD) test --no-fail-fast --exclude src/tools/tidy
# To run a specific test, run something like:
#   $ debian/rules override_dh_auto_test-arch \
#     RUSTBUILD_TEST_FLAGS="src/test/run-make --test-args extern-fn-struct"
# See src/bootstrap/README.md for more options.
RUSTBUILD_TEST_FLAGS =

# https://github.com/rust-lang/rust/issues/89744
# TODO: remove when we update cargo to 1.55 / 0.56
# upstream bug still exists and is under investigation, but is hidden by newer cargo
export CARGO_PROFILE_RELEASE_BUILD_OVERRIDE_OPT_LEVEL=0

update-version:
	oldver=$(shell $(SED_RUSTC_BUILDDEP) | sed -ne 's/.*(<= \(.*\)).*/\1/gp' | $(SED_VERSION_SHORT)); \
	newver=$(RUST_VERSION); \
	debian/update-version.sh $$oldver $$newver $(RUST_LONG_VERSION) $(CARGO_NEW)

# Below we detect how we're supposed to bootstrap the stage0 compiler. See
# README.Debian for more details of the cases described below.
#
PRECONFIGURE_CHECK = :
HAVE_BINARY_TARBALL := $(shell ls -1 stage0/*/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l)
DOWNLOAD_BOOTSTRAP := false
# allow not using the binary tarball although it exists
#ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 powerpc ppc64el s390x))
#  HAVE_BINARY_TARBALL := 0
#endif
ifeq (0,$(HAVE_BINARY_TARBALL))
    # Case A (Building from source): the extracted source tree does not include
    # a bootstrapping tarball for the current architecture e.g. because the
    # distro already has a rustc for this arch, or the uploader expects that
    # this requirement be fulfilled in some other way.
    #
    # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
    # In this case, we use the distro's rustc - either the previous or current version.
    ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
        # Make it easier to test against a custom rustc
        ifneq (,$(RUST_DESTDIR))
        RUST_LIBRARY_PATH := $(RUST_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(RUST_DESTDIR)/usr/lib
        LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(RUST_LIBRARY_PATH),$(RUST_LIBRARY_PATH))
        export LD_LIBRARY_PATH
        endif
    #
    # Case A-2: the builder selected the "dlstage0" build profile.
    # In this case, the rust build scripts will download a stage0 into stage0/ and use that.
    # We don't need to do anything specific in this build file, so this case is empty.
    else
        DOWNLOAD_BOOTSTRAP := true
    endif
else
    # Case B (Bootstrapping a new distro): the extracted source tree does
    # include a bootstrapping tarball for the current architecture; see the
    # `source_orig-stage0` target below on how to build this.
    #
    # In this case, we'll bootstrap from the stage0 given in that tarball.
    # To ensure the uploader of the .dsc didn't make a mistake, we first check
    # that rustc isn't a Build-Depends for the current architecture.
    ifneq (,$(shell $(SED_RUSTC_BUILDDEP)))
    ifeq (,$(shell $(SED_RUSTC_BUILDDEP) | grep '!$(DEB_HOST_ARCH)'))
        PRECONFIGURE_CHECK = $(error found matches for stage0/*/*$(DEB_HOST_RUST_TYPE)*, \
          but rustc might be a Build-Depends for $(DEB_HOST_ARCH))
    endif
    endif
endif

BUILD_DOCS := true
ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
  BUILD_DOCS := false
endif
ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
  BUILD_DOCS := false
endif

BUILD_WASM := false

BUILD_WINDOWS := false

MAKE_OPTIMISATIONS := true
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  MAKE_OPTIMISATIONS := false
endif

VERBOSITY_SUB := $(words $(filter terse,$(DEB_BUILD_OPTIONS)))
VERBOSITY_ADD := $(words $(filter verbose,$(DEB_BUILD_OPTIONS)))
VERBOSITY := $(shell expr 2 + $(VERBOSITY_ADD) - $(VERBOSITY_SUB))

ifeq ($(shell test $(VERBOSITY) -ge 3; echo $$?),0)
  export DH_VERBOSE=1
endif

ifeq ($(shell test $(VERBOSITY) -le 0; echo $$?),0)
  export DH_QUIET=1
.SILENT:
endif

# Build products or non-source files in src/, that shouldn't go in rust-src
SRC_CLEAN = src/bootstrap/bootstrap.pyc \
	src/bootstrap/__pycache__ \
	src/etc/__pycache__/

# Try to work around #933045
ifneq (,$(filter $(DEB_BUILD_ARCH), mips mipsel))
  SYSTEM_WORKAROUNDS += export MALLOC_ARENA_MAX=1;
endif

# List generated files
FILES_TO_PRECONFIGURE := $(wildcard debian/*.in)
FILES_TO_PRECONFIGURE_OUT := $(subst X.Y,$(RUST_VERSION),\
  $(filter-out debian/control,\
    $(patsubst %.in,%,$(FILES_TO_PRECONFIGURE))\
  )\
)
DEFINED_SRC_NAME = $(shell dpkg-parsechangelog -S Source)

%:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel --with bash-completion

.PHONY: .dbg-windows
.dbg-windows:
	@echo host=$(DEB_BUILD_ARCH) target=$(DEB_HOST_ARCH) BUILD_WINDOWS=$(BUILD_WINDOWS) WINDOWS_ARCH=$(WINDOWS_ARCH)

.PHONY: build
build:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel --with bash-completion

override_dh_clean: debian/control
	# Upstream contains a lot of these
	dh_clean -XCargo.toml.orig

debian/preconfigure.stamp: $(FILES_TO_PRECONFIGURE) debian/changelog
ifneq ($(DEFINED_SRC_NAME),rustc-$(RUST_VERSION))
	$(error Source package name is incorrect:\
